#! /bin/sh

# Test recognition of GCC internal format strings.

tmpfiles=""
trap 'rm -fr $tmpfiles' 1 2 3 15

tmpfiles="$tmpfiles f-gi-1.data"
cat <<\EOF > f-gi-1.data
# Valid: no argument
"abc%%"
# Valid: one character argument
"abc%c"
# Valid: one string argument
"abc%s"
# Valid: one integer argument
"abc%i"
# Valid: one integer argument
"abc%d"
# Valid: one integer argument
"abc%o"
# Valid: one integer argument
"abc%u"
# Valid: one integer argument
"abc%x"
# Valid: one integer and one string argument
"abc%.*s"
# Valid: one pointer argument
"abc%H"
# Valid: one pointer argument
"abc%D"
# Valid: one pointer argument
"abc%F"
# Valid: one pointer argument
"abc%T"
# Valid: one pointer argument
"abc%A"
# Valid: one pointer argument
"abc%C"
# Valid: one pointer argument
"abc%E"
# Valid: one pointer argument
"abc%L"
# Valid: one pointer argument
"abc%O"
# Valid: one pointer argument
"abc%P"
# Valid: one pointer argument
"abc%Q"
# Valid: one pointer argument
"abc%V"
# Valid: one argument with flags
"abc%+#Ag"
# Valid: one argument with size specifier
"abc%li"
# Invalid: unterminated
"abc%"
# Invalid: unknown format specifier
"abc%y"
# Invalid: precision with non-string
"abc%.*c"
# Invalid: twice precision
"abc%.*.*s"
# Valid: three arguments
"abc%d%u%u"
# Invalid: a numbered argument
"abc%1$d"
EOF

: ${XGETTEXT=xgettext}
n=0
while read comment; do
  read string
  n=`expr $n + 1`
  tmpfiles="$tmpfiles f-gi-1-$n.in f-gi-1-$n.po"
  cat <<EOF > f-gi-1-$n.in
gettext(${string});
EOF
  ${XGETTEXT} -L GCC-source -o f-gi-1-$n.po f-gi-1-$n.in || exit 1
  test -f f-gi-1-$n.po || exit 1
  fail=
  if echo "$comment" | grep 'Valid:' > /dev/null; then
    if grep gcc-internal-format f-gi-1-$n.po > /dev/null; then
      :
    else
      fail=yes
    fi
  else
    if grep gcc-internal-format f-gi-1-$n.po > /dev/null; then
      fail=yes
    else
      :
    fi
  fi
  if test -n "$fail"; then
    echo "Format string recognition error:" 1>&2
    cat f-gi-1-$n.in 1>&2
    echo "Got:" 1>&2
    cat f-gi-1-$n.po 1>&2
    exit 1
  fi
  rm -f f-gi-1-$n.in f-gi-1-$n.po
done < f-gi-1.data

rm -fr $tmpfiles

exit 0
